import { createRoute } from "../../../modules/api-utils/createRoute";
import { unifiSites } from "../../../managers/unifiSites";
import { apiResponse } from "../../../modules/api-utils/apiResponse";
import { ContentfulStatusCode } from "hono/utils/http-status";
import { authMiddleware } from "../../middleware/authorization";

/* GET /v1/unifi/site/:id/wifi-limits */
export default createRoute(
  "get",
  ["/site/:id/wifi-limits"],
  async (c) => {
    const site = await unifiSites.fetch(c.req.param("id"));
    const limits = await unifiSites.getWifiLimits(site.siteId);
    const response = apiResponse.successful(
      "UniFi WiFi Limits Fetched Successfully!",
      limits,
    );
    return c.json(response, response.status as ContentfulStatusCode);
  },
  authMiddleware({
    permissions: ["unifi.access", "unifi.site.wifi-limits"],
  }),
);
